const long baudRate = 57600; 
boolean isset = false;
int incomingByte;
int firstByte;
int secondByte;
int solenoidPin;
int period;
long offTimes[8];
long now;

void  setup()
{
  // start serial communication
  Serial.begin(baudRate);
  
  // set necessary pins to output mode
  for (int i = 0; i < 8; i++)
  {
    pinMode(i + 2, OUTPUT);
  }
}


void loop()
{
  // check serial in for incoming messages
  // a complete messages consists of two bytes
  // the bit mask looks as followed:
  //
  // 0 P P P P T T T   1 T T T T T T T
  //
  // 0, 1 :  header of first and second byte
  // P    :  Pin Number 1-16 (currently only 8 are in use)
  // T    :  time duration in ms (0-1023ms)
  if(Serial.available() != 0)
  {
    incomingByte = Serial.read();
    
    
    // CODE FOR HANDSHAKE
    if(incomingByte == 255)
    {
      Serial.print("SOL 0 1");
    }
    // END CODE FOR HANDSHAKE
    
    if((incomingByte >> 7) == 0)
    {
      firstByte = incomingByte;
    }
    else
    {
      secondByte = incomingByte;
      // as second bytes is received, the message is complete
      isset = true;
    }
  }
  
  // if a full message is received:
  //   - turn respective pin to HIGH
  //   - set the offTime for respective pin
  
  if(isset)
  {
    solenoidPin = firstByte >> 3;
    period = ((firstByte % 8) << 7) + (secondByte % 128);
    offTimes[solenoidPin] = millis() + long(period);
    digitalWrite(solenoidPin + 2, HIGH);
    isset = false;
  }
  
  // check, if it is time to turn one or more pins off
  now = millis();
  for (int pin = 0; pin < 8; pin++)
  {
    if(now >= offTimes[pin])
    {
      digitalWrite(pin + 2, LOW);
    }
  }
}
